"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.FlarumApi = exports.generateApiToken = void 0;
var crypto = __importStar(require("node:crypto"));
var generateApiToken = function (userId) {
    var id = crypto.randomBytes(20).toString('hex');
    var createdAt = new Date().toISOString().slice(0, 19).replace('T', ' ');
    console.log("Open the Forum's database. Then execute the following database query: \n\n\tINSERT INTO ".concat(process.env.FLARUM_DB_PREFIX, "api_keys (`key`, `user_id`, `created_at`) VALUES ('").concat(id, "', '").concat(userId, "', '").concat(createdAt, "');\n\n"));
    console.log("Then, save it in the .env and use it with the client");
};
exports.generateApiToken = generateApiToken;
var FlarumApi = /** @class */ (function () {
    /**
     *
     * @param endpoint Your forum's API endpoint. It ends with 'api'
     * @param token Your API Key. Use generateApiToken function.
     * @param verbose Optionally, if set, it will print the progress. For debug only
     */
    function FlarumApi(endpoint, verbose) {
        var _this = this;
        this.endpoint = "";
        this.token = "";
        this.userId = 0;
        this.verbose = false;
        /**
         * Creates a new FlarumApi authorized with the given token.
         * @param token
         * @returns FlarumApi
         */
        this.cloneWithToken = function (token, userId) {
            var api = new FlarumApi(_this.endpoint, _this.verbose);
            api.token = token;
            if (userId) {
                api.userId = userId;
            }
            return api;
        };
        /**
         * @description Authorize the Client to access the Flarum Endpoint.
         * Without authorization, Most of the POST/PUT/DELETE operations are not available.
         *
         * Flarum supports two way of authentication, either through API Keys.
         * Or through the Access Tokens.
         * @param userNameOrUserId if authorizing with api key, pass the user ID, otherwise pass the username
         * @param passwordOrApiToken if authorizing with the api key, pass api key, otherwise pass the password.
         * @returns string for error and undefined in case of success
         */
        this.authorize = function (userNameOrUserId, passwordOrApiToken) { return __awaiter(_this, void 0, void 0, function () {
            var body, url, response, json, authorizeReply, e_1;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (typeof (userNameOrUserId) == 'number') {
                            this.token = passwordOrApiToken;
                            this.userId = userNameOrUserId;
                            return [2 /*return*/, { token: this.token }];
                        }
                        body = {
                            identification: userNameOrUserId,
                            password: passwordOrApiToken,
                        };
                        url = "".concat(this.endpoint, "/token");
                        if (this.verbose) {
                            console.log("Authorize in: ".concat(url, " username: ").concat(userNameOrUserId, " password: ").concat(passwordOrApiToken));
                        }
                        return [4 /*yield*/, fetch(url, {
                                headers: {
                                    'Content-Type': "application/json"
                                },
                                method: "POST",
                                body: JSON.stringify(body),
                            })];
                    case 1:
                        response = _a.sent();
                        if (!response.ok) {
                            return [2 /*return*/, "Response Status ".concat(response.status, ": ").concat(response.statusText)];
                        }
                        _a.label = 2;
                    case 2:
                        _a.trys.push([2, 4, , 5]);
                        return [4 /*yield*/, response.json()];
                    case 3:
                        json = _a.sent();
                        authorizeReply = json;
                        if (authorizeReply === undefined) {
                            throw "Failed to get AuthorizeReply";
                        }
                        this.token = authorizeReply.token;
                        this.userId = parseInt(authorizeReply.userId);
                        if (this.verbose) {
                            console.log("Access Token (".concat(this.token, ") was returned for user ").concat(this.userId));
                        }
                        return [3 /*break*/, 5];
                    case 4:
                        e_1 = _a.sent();
                        return [2 /*return*/, JSON.stringify(e_1)];
                    case 5: return [2 /*return*/, { token: this.token }];
                }
            });
        }); };
        /**
         * @description Get information about the forum, including groups and tags
         */
        this.get = function () { return __awaiter(_this, void 0, void 0, function () {
            var url, response, json, reply, e_2;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        url = "".concat(this.endpoint);
                        return [4 /*yield*/, fetch(url, {
                                headers: {
                                    'Content-Type': "application/json"
                                },
                                method: "GET",
                            })];
                    case 1:
                        response = _a.sent();
                        if (!response.ok) {
                            return [2 /*return*/, "Response Status ".concat(response.status, ": ").concat(response.statusText)];
                        }
                        _a.label = 2;
                    case 2:
                        _a.trys.push([2, 4, , 5]);
                        return [4 /*yield*/, response.json()];
                    case 3:
                        json = _a.sent();
                        reply = json;
                        if (reply === undefined) {
                            throw "Failed to get Forum";
                        }
                        return [2 /*return*/, reply];
                    case 4:
                        e_2 = _a.sent();
                        return [2 /*return*/, JSON.stringify(e_2)];
                    case 5: return [2 /*return*/];
                }
            });
        }); };
        /**
         * @description Update forum config
         */
        this.update = function () { return __awaiter(_this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                // https://github.com/flarum/flarum.github.io/blob/20322c0e6011e4f304ae7e95f41594a0b086bc27/_docs/api.md
                throw "TODO: implement";
            });
        }); };
        /**
         * @description fetch the data through authentication
         */
        this.getFetch = function (url) { return __awaiter(_this, void 0, void 0, function () {
            var response, json, e_3;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, fetch(url, {
                            headers: {
                                'Content-Type': "application/json",
                                'Authorization': "Token ".concat(this.token)
                            },
                            method: "GET",
                        })];
                    case 1:
                        response = _a.sent();
                        if (!response.ok) {
                            return [2 /*return*/, "Response Status ".concat(response.status, ": ").concat(response.statusText)];
                        }
                        _a.label = 2;
                    case 2:
                        _a.trys.push([2, 4, , 5]);
                        return [4 /*yield*/, response.json()];
                    case 3:
                        json = _a.sent();
                        return [2 /*return*/, json];
                    case 4:
                        e_3 = _a.sent();
                        return [2 /*return*/, JSON.stringify(e_3)];
                    case 5: return [2 /*return*/];
                }
            });
        }); };
        this.postFetch = function (url, body) { return __awaiter(_this, void 0, void 0, function () {
            var response, json, e_4;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, fetch(url, {
                            headers: {
                                'Content-Type': "application/json",
                                'Authorization': "Token ".concat(this.token)
                            },
                            method: "POST",
                            body: body,
                        })];
                    case 1:
                        response = _a.sent();
                        if (!response.ok) {
                            return [2 /*return*/, "Response Status ".concat(response.status, ": ").concat(response.statusText)];
                        }
                        _a.label = 2;
                    case 2:
                        _a.trys.push([2, 4, , 5]);
                        return [4 /*yield*/, response.json()];
                    case 3:
                        json = _a.sent();
                        return [2 /*return*/, json];
                    case 4:
                        e_4 = _a.sent();
                        return [2 /*return*/, JSON.stringify(e_4)];
                    case 5: return [2 /*return*/];
                }
            });
        }); };
        this.endpoint = endpoint;
        if (verbose) {
            this.verbose = verbose;
        }
        else {
            this.verbose = false;
        }
    }
    return FlarumApi;
}());
exports.FlarumApi = FlarumApi;
