"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.FlarumUsers = void 0;
var FlarumUsers = /** @class */ (function () {
    function FlarumUsers() {
    }
    var _a;
    _a = FlarumUsers;
    /**
     * @description get all users
     * @param userNameOrUserId if authorizing with api key, pass the user ID, otherwise pass the username
     * @param passwordOrApiToken if authorizing with the api key, pass api key, otherwise pass the password.
     * @returns string for error and undefined in case of success
     */
    FlarumUsers.getAll = function (api, filter) { return __awaiter(void 0, void 0, void 0, function () {
        var urlParams, q, response, reply;
        return __generator(_a, function (_b) {
            switch (_b.label) {
                case 0:
                    urlParams = "".concat(api.endpoint, "/users");
                    q = '';
                    if (filter && filter.userName) {
                        q = filter.userName;
                    }
                    if (q.length > 0) {
                        urlParams += "?filter[q]=".concat(q);
                    }
                    return [4 /*yield*/, api.getFetch(urlParams)];
                case 1:
                    response = _b.sent();
                    if (typeof (response) === 'string') {
                        return [2 /*return*/, response];
                    }
                    reply = response;
                    if (reply === undefined) {
                        throw "Failed to get Users";
                    }
                    return [2 /*return*/, reply];
            }
        });
    }); };
    FlarumUsers.getNext = function (api, discussions) { return __awaiter(void 0, void 0, void 0, function () {
        var empty, response, reply;
        return __generator(_a, function (_b) {
            switch (_b.label) {
                case 0:
                    if (!discussions.links.next) {
                        empty = {
                            links: {
                                first: discussions.links.first,
                            },
                            data: [],
                            included: [],
                        };
                        return [2 /*return*/, empty];
                    }
                    return [4 /*yield*/, api.getFetch(discussions.links.next)];
                case 1:
                    response = _b.sent();
                    if (typeof (response) === 'string') {
                        return [2 /*return*/, response];
                    }
                    reply = response;
                    if (reply === undefined) {
                        throw "Failed to get Users";
                    }
                    return [2 /*return*/, reply];
            }
        });
    }); };
    FlarumUsers.getPrev = function (api, discussions) { return __awaiter(void 0, void 0, void 0, function () {
        var empty, response, reply;
        return __generator(_a, function (_b) {
            switch (_b.label) {
                case 0:
                    if (!discussions.links.prev) {
                        empty = {
                            links: {
                                first: discussions.links.first,
                            },
                            data: [],
                            included: [],
                        };
                        return [2 /*return*/, empty];
                    }
                    return [4 /*yield*/, api.getFetch(discussions.links.prev)];
                case 1:
                    response = _b.sent();
                    if (typeof (response) === 'string') {
                        return [2 /*return*/, response];
                    }
                    reply = response;
                    if (reply === undefined) {
                        throw "Failed to get Users";
                    }
                    return [2 /*return*/, reply];
            }
        });
    }); };
    /**
     * Create a new discussion
     * POST /api/discussions
     * @param api
     * @param discussion
     */
    FlarumUsers.create = function (api, user) { return __awaiter(void 0, void 0, void 0, function () {
        var url, body, response;
        return __generator(_a, function (_b) {
            switch (_b.label) {
                case 0:
                    url = "".concat(api.endpoint, "/users");
                    user.data.attributes.isEmailConfirmed = true;
                    body = JSON.stringify(user);
                    return [4 /*yield*/, api.postFetch(url, body)];
                case 1:
                    response = _b.sent();
                    if (typeof (response) === 'string') {
                        return [2 /*return*/, response];
                    }
                    return [2 /*return*/, response];
            }
        });
    }); };
    /**
     * @description Get information about the forum, including groups and tags
     */
    FlarumUsers.get = function (api, id) { return __awaiter(void 0, void 0, void 0, function () {
        var urlParams, response, reply;
        return __generator(_a, function (_b) {
            switch (_b.label) {
                case 0:
                    urlParams = "".concat(api.endpoint, "/users/").concat(id);
                    return [4 /*yield*/, api.getFetch(urlParams)];
                case 1:
                    response = _b.sent();
                    if (typeof (response) === 'string') {
                        return [2 /*return*/, response];
                    }
                    reply = response;
                    if (reply === undefined) {
                        throw "Failed to get User";
                    }
                    return [2 /*return*/, reply];
            }
        });
    }); };
    /**
     * PATCH /api/discussions/:id - update the discussion
     * @param api
     * @param id
     * @returns
     */
    FlarumUsers.update = function (api, id, data) { return __awaiter(void 0, void 0, void 0, function () {
        return __generator(_a, function (_b) {
            throw "not implemented yet";
        });
    }); };
    /**
     * @description Update forum config
     */
    FlarumUsers.delete = function (api, id) { return __awaiter(void 0, void 0, void 0, function () {
        return __generator(_a, function (_b) {
            // https://github.com/flarum/flarum.github.io/blob/20322c0e6011e4f304ae7e95f41594a0b086bc27/_docs/api.md
            throw "TODO: implement";
        });
    }); };
    /**
     * Checks whether the given token is valid or not. In case of an error returns an error string.
     * @param api FlarumApi.
     * @param token access token
     */
    FlarumUsers.canAccess = function (api, token) { return __awaiter(void 0, void 0, void 0, function () {
        var url, tempApi, response;
        return __generator(_a, function (_b) {
            switch (_b.label) {
                case 0:
                    url = "".concat(api.endpoint, "/access-tokens");
                    tempApi = api.cloneWithToken(token);
                    return [4 /*yield*/, tempApi.getFetch(url)];
                case 1:
                    response = _b.sent();
                    if (typeof (response) === 'string') {
                        return [2 /*return*/, false];
                    }
                    return [2 /*return*/, true];
            }
        });
    }); };
    return FlarumUsers;
}());
exports.FlarumUsers = FlarumUsers;
